// packageA//pages/myGift/myGift.js
const app = getApp();
let self = null;
var os = app.globalData.setting;
var t_pay = require("../../../utils/pay2.js");
var util = require('../../../utils/util.js');
var ut=util;

Page({

  /**
   * 页面的初始数据
   */
  data: {
		tabArr: ['礼包列表', '我的礼包'],
		currentIndex: 0,
		
		list: null,
		isLoading: false, // 检测是否已经发送请求,防止重复发送请求
		noMore: false, // 检测是否有更多数据,true为没有更多数据,false为还有数据
		pageNum: 1, // 当前页数
	    iurl: os.imghost, //图片前缀网址
	    is_summit_ing:0,   //是不是提交申请
	    sear_key:'' //顶部搜索关键子
  },
	
	clickTab(e) {
		let index = e.target.dataset.index;
		let url = '';
		let data = {
			store_id: app.globalData.setting.stoid,
			user_id: app.globalData.user_id,
		};

		if(index!=this.data.currentIndex){
			this.data.sear_key='';
			let lb_sear= this.selectComponent("#lb_sear"); //组件的id
			if(lb_sear){
				lb_sear.clear();
			}

		}

		this.setData({
			list: null,
			pageNum: 1,
			noMore: false,
			currentIndex: index,
		});
		
		if(index == 0) {
			url = '/api/weshop/libao/libaoForm/page';
            data.timetype=1;
		} else if(index == 1) {
			url = '/api/weshop/libao/libaoFormvip/page';
		};



		if(this.data.sear_key){
			data.key_str=this.data.sear_key;
		}
		
		this.getData(true, url, data);

	},

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

	  //定义第一次进入
	  this.data.fir_in=1;

	    self = this;
		if(options.index){
			this.setData({currentIndex:1}); //查看我的礼包
		}
		app.isLogin().then(function(data) {//进入页面前已经授权登录成功
			self.setData({
				userInfo: data,
			});
		});

	  getApp().request.promiseGet("/api/weshop/ad/page?pid=901&store_id=" + os.stoid, {
		  data: {
			  enabled: 1
		  }
	  }).then(res => {
		  if (res.data.code == 0 && res.data.data && res.data.data.pageData && res.data.data.pageData.length > 0) {
			  var a = res.data.data.pageData;
			  var tt = {
				  'ad_code': os.imghost + a[0].ad_code,
				  'media_link': '',
				  'ad_weapplink': a[0].ad_weapplink,
				  'bgcolor': a[0].bgcolor,
			  };
			  self.setData({ ad_data: tt });
		  }
	  })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

	    this.data.is_summit_ing=0;


	  var th=this;
      //判断是不是第一次进入
	  if(this.data.fir_in){
		  this.data.fir_in=0;
	  }else{
		  //富友插件支付
		  util.fy_back('',0)
		  t_pay.set_fir();

		  //-- 通联的第三方支付的返回优化 --
		  util.is_pay_ok(th.data.ok_order_sn,"none","none",function (){
			  if(!th.data.ok_order_sn) return false;

			  var b_url="/api/weshop/libao/libaoFormvip/page";
			  var rq_data={
				      store_id: app.globalData.setting.stoid,
					  user_id: app.globalData.user_id,
					  number: th.data.ok_order_sn
			  };

			  getApp().request.promiseGet(b_url,
				  {data:rq_data}).then(res=>{
				  if(ut.ajax_ok(res)){
					  var item=res.data.data.pageData[0];
					  if(item.fbillstate==1){
						  //支付支付，返回首页
						  util.m_toast('支付成功');
					  }else{
						  //支付支付，返回首页
						  util.m_toast('支付失败');
					  }
				  }
			  })
		  });

	  }


        getApp().check_can_share();
		if(app.globalData.userInfo) {
			if(!this.data.isLogin) {
				this.setData({
					userInfo: app.globalData.userInfo,
					imghost: app.globalData.setting.imghost,
					isLogin: true,
					now:Date.parse(new Date()) / 1000,
				});

				var index=this.data.currentIndex;
				let url = '';
				let data = {
					store_id: app.globalData.setting.stoid,
					user_id: app.globalData.user_id,
				};
				this.setData({
					list: null,
					pageNum: 1,
					noMore: false,
				});

				if(index == 0) {
					url = '/api/weshop/libao/libaoForm/page';
					data.timetype=1;
				} else if(index == 1) {
					url = '/api/weshop/libao/libaoFormvip/page';
				};

				this.getData(true, url, data);
			};
		};
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

      var url="";
      var index=this.data.currentIndex;

      var req_data={
          store_id: app.globalData.setting.stoid,
          user_id: app.globalData.user_id,
      }

	  if(this.data.sear_key){
		  req_data.key_str=this.data.sear_key;
	  }

      if(index == 0) {
          url = '/api/weshop/libao/libaoForm/page';
          req_data.timetype=1;
      } else if(index == 1) {
          url = '/api/weshop/libao/libaoFormvip/page';
      };


		this.scrollToLower(url, req_data);
  },

  /**
   * 用户点击右上角分享
   */
   onShareAppMessage: function () {   	  getApp().globalData.no_clear=1

  },
	
	/**
	 * 请求数据
	 */
	getData: function(isInit, url, data) {
		app.request.promiseGet(url, {
			data: data,
			isShowLoading: true,
		})
		.then(function(res) {
			console.log(res);
			if(res.data.code == 0) {
		
				self.setData({
					isLoading: false
				});
				
				if(isInit) {// 第一次加载
					self.setData({
						list: res.data.data
					});
					// console.log(this.data.list);
				} else {
					self.setData({
						'list.pageData': self.data.list.pageData.concat(res.data.data.pageData)
					});
					
				};
				
				if((res.data.data.pageData.length == 0) || (res.data.data.pageSize * res.data.data.page >= res.data.data.total)) {
					self.setData({
						noMore: true
					});
				};
				
			} else {
				self.setData({
					'list.pageData': []
				});
			};
			
		})
		.catch(function(err) {
			console.log('出错拉！！！！',err);
			self.setData({
				'list.pageData': []
			});
		});
	},
	
	
	/**
	 * 上拉加载
	 */
	scrollToLower(url, requestData) {
		// 数据总量
		let total = this.data.list.total;
		// 单页最大数据量
		let pageSize = this.data.list.pageSize;
		// 如果数据总量不为0且小于或等于单页最大数据量，说明数据已全部加载，显示‘没有更多了’
		if((total != 0)&&(total <= pageSize)) {
			this.setData({
				noMore: true
			});
		};
		
		if(!this.data.isLoading && !this.data.noMore) {
			this.setData({
				isLoading: true,
				pageNum: this.data.pageNum + 1
			});
			requestData.page = this.data.pageNum;
			this.getData(false, url, requestData);
		};
	},
	
	/**
	 * 点击跳转
	 */
	goto(e) {
		let url = '';
		if(e.target.dataset.url) {
			url = e.target.dataset.url;
		} else {
			url = e.currentTarget.dataset.url;
		}
		app.goto(url);
	},


	//-- 礼包购买 --
	GetBuyPrice: function(e) {
		var th = this,that=th;
		var index=e.currentTarget.dataset.index;
		var item=that.data.list.pageData[index];

		var id = item.id; //活动id
		var my_confirm = th.selectComponent("#my_confirm"); //组件的id
		var user=getApp().globalData.userInfo;


		if(this.data.is_summit_ing) return false;
		this.data.is_summit_ing=0;

		my_confirm.open(
			"是否确定购买该礼包",
			"取消",
			"确定",
			function() {
				my_confirm.open_cancel(0);
			},
			function() {
				my_confirm.open_cancel(0);
				var json = {
					"lbid": id, //活动Id
					"paytype": 2, //1=积分兑换 2=购买
					"store_id": os.stoid, //商家Id
					"user_id": user.user_id, //用户ID
				};
				t_pay.set_pay_url("/api/weshop/libao/libaoFormvip/libaoOrder");
				t_pay.pay(json,function (){
					th.data.is_summit_ing=0;
					getApp().my_warnning("支付成功", 1, th);
				},function (e){
					th.data.is_summit_ing=0;
					getApp().my_warnning(e, 0, th);
				},th)
				// var url = "/api/weshop/libao/libaoFormvip/libaoOrder";
				// getApp().request.post(url,
				// 	{
				// 		data:json,
				// 		success:function(res) {
				// 			if (res.data.code == 0 && res.data.data) {
				// 				res = res.data.data;
				//
				// 				getApp().globalData.no_clear=1;
				//
				// 				wx.requestPayment({
				// 					timeStamp: String(res.timeStamp),
				// 					nonceStr: res.nonceStr,
				// 					package: res.packageValue,
				// 					signType: res.signType,
				// 					paySign: res.paySign,
				// 					success: function(res) {
				// 						getApp().my_warnning("支付成功", 1, th);
				// 					},
				// 					fail: function(res) {
				// 						getApp().my_warnning("取消支付", 0, th);
				// 					}
				// 				});
				// 			} else {
				// 				getApp().my_warnning(res.data.msg, 0, th);
				// 			}
				// 		}
				// 	})
			})
	},

	//-- 积分兑换 --
	GetBuyIntegral: function(e) {
		var th = this,that=th;
		var index=e.currentTarget.dataset.index;
		var item=that.data.list.pageData[index];

		var id = item.id; //活动id
		var my_confirm = th.selectComponent("#my_confirm"); //组件的id
		var user=getApp().globalData.userInfo;
		my_confirm.open(
			"是否确定兑换该礼包",
			"取消",
			"确定",
			function() {
				my_confirm.open_cancel(0);
			},
			function() {
				my_confirm.open_cancel(0);
				var json = {
					"lbid": id, //活动Id
					"paytype": 1, //1=积分兑换 2=购买
					"store_id": os.stoid, //商家Id
					"user_id": user.user_id, //用户ID
				};
				var url = "/api/weshop/libao/libaoFormvip/libaoOrder";
				getApp().request.post(url,{
					data:json,
					success:function(res) {
						if (res.data.code == 0) {
							getApp().my_warnning("兑换成功！", 1, th);
						} else {
							getApp().my_warnning(res.data.msg, 0, th);
						}
					},
				})

			})
	},
	
	
	show_remark:function(e){
		var index=e.currentTarget.dataset.index;
		var item=this.data.list.pageData[index];
		this.setData({
			show_rem_pop:1,
			pop_remark_text:item.lbintro
		})
	},
	
	close_remark:function(){
		this.setData({show_rem_pop:0,})
	},

	search_lb(){

		let index=this.data.currentIndex;
		let url = '';
		let data = {
			store_id: app.globalData.setting.stoid,
			user_id: app.globalData.user_id,
		};
		this.setData({
			list: null,
			pageNum: 1,
			noMore: false,
		});

		if(index == 0) {
			url = '/api/weshop/libao/libaoForm/page';
			data.timetype=1;
		} else if(index == 1) {
			url = '/api/weshop/libao/libaoFormvip/page';
		};

		if(this.data.sear_key){
			data.key_str=this.data.sear_key;
		}
		this.getData(true, url, data);
	},

	input_sear(e){
		let value = e.detail;
		this.data.sear_key=value;
	}

})